#!/usr/bin/env rexx


::routine buttonClicked public
  slotDir=arg(arg())
  /* @get(idLabelCounter) */
  counter = idLabelCounter~text
  if counter < 21 then counter = counter + 1
  idLabelCounter~text=counter
  /* @get(idLabel1) */
  idLabel1~text= racehandler(counter,0)


::routine buttonClicked2 public
  slotDir=arg(arg())
  /* @get(idLabelCounter) */
  counter = idLabelCounter~text
  if counter > 0 then counter = counter-1
  idLabelCounter~text=counter
  /* @get(idLabel1) */
  idLabel1~text= racehandler(counter,0)

::routine buttonClicked3 public
  slotDir=arg(arg())
  now=.dateTime~new
  say now
  /* @get(idLabelCounter) */
  idLabelCounter~text=9
  /* @get(idLabel1) */
  idLabel1~text= racehandler(counter)


::routine racehandler public
  source = "./data/raceschedule.xml" -- can be html, xml; a local file or URL
  src=.bsf~new("java.io.File", source) -- create File object
  clzJsoup = bsf.importClass("org.jsoup.Jsoup") -- import Jsoup class
  root = clzJsoup~parse(src)

  elements = root~select("RaceName")
  do i = 0 to elements~size() - 1
      races.i = elements~get(i)~text()
  end

  dates = root~select("Date")
  rmax = 0
  do i = 0 to dates~size() - 1
      if dates~get(i)~parent()~nodeName() = "race" then do
          races.rmax.date = dates~get(i)~text()
          rmax = rmax + 1
      end
  end
  
  currentRace = arg(1)

  if arg(2) \= 0 then do
    a = .dateTime~new
    a = SUBSTR(a,1,10)
    do i = 0 to rmax - 1
      if races.i.date > a then do
        return races.i.date ": " races.i
      end
    end
  end
  
  return races.currentRace.date ": " races.currentRace
